.text
.align 4
.globl csum_basic

/* Experiments with Ethernet and SLIP connections show that buff
** is aligned on either a 2-byte or 4-byte boundary.  We get at
** least a twofold speedup on 486 and Pentium if it is 4-byte aligned.
** Fortunately, it is easy to convert 2-byte alignment to 4-byte
** alignment for the unrolled loop.
*/
csum_basic:
	movl	%ecx, %ebx
	movl	%ecx, %edx
	shrl	$7, %ecx
	andl	$0x7c, %ebx
	addl	%ebx, %esi
	shrl	$2, %ebx
	negl	%ebx
	leal	50f(%ebx,%ebx,2), %ebx
	clc
	jmp	*%ebx
40:
	leal	128(%esi), %esi
	adcl	-128(%esi), %eax
	adcl	-124(%esi), %eax
	adcl	-120(%esi), %eax
	adcl	-116(%esi), %eax
	adcl	-112(%esi), %eax
	adcl	-108(%esi), %eax
	adcl	-104(%esi), %eax
	adcl	-100(%esi), %eax
	adcl	-96(%esi), %eax
	adcl	-92(%esi), %eax
	adcl	-88(%esi), %eax
	adcl	-84(%esi), %eax
	adcl	-80(%esi), %eax
	adcl	-76(%esi), %eax
	adcl	-72(%esi), %eax
	adcl	-68(%esi), %eax
	adcl	-64(%esi), %eax
	adcl	-60(%esi), %eax
	adcl	-56(%esi), %eax
	adcl	-52(%esi), %eax
	adcl	-48(%esi), %eax
	adcl	-44(%esi), %eax
	adcl	-40(%esi), %eax
	adcl	-36(%esi), %eax
	adcl	-32(%esi), %eax
	adcl	-28(%esi), %eax
	adcl	-24(%esi), %eax
	adcl	-20(%esi), %eax
	adcl	-16(%esi), %eax
	adcl	-12(%esi), %eax
	adcl	-8(%esi), %eax
	adcl	-4(%esi), %eax
50:
	decl	%ecx
	jge	40b
	
	adcl	$0, %eax
	movl	%edx, %ecx
	andl	$3, %ecx
	ret
